'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _merge2 = require('lodash/merge');

var _merge3 = _interopRequireDefault(_merge2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getStyles(isVisible) {
  var styles = {
    overlay: {
      position: 'relative'
    },
    label: {
      position: 'absolute',
      left: 'calc(50% - 32px)',
      top: 'calc(50% - 10px)',
      fontSize: '32px',
      color: 'rgba(0,0,0,.64)',
      display: 'none'
    },
    content: {
      opacity: 1
    }
  };

  if (isVisible) {
    (0, _merge3.default)(styles, {
      overlay: {
        pointerEvents: 'none'
      },
      label: {
        display: 'block'
      },
      content: {
        opacity: 0.4
      }
    });
  }

  return styles;
}

exports.default = (0, _createReactClass2.default)({
  displayName: 'Overlay',

  propTypes: {
    isVisible: _propTypes2.default.bool
  },

  render: function render() {
    var isVisible = this.props.isVisible;

    var styles = getStyles(isVisible);

    return _react2.default.createElement(
      'div',
      { style: styles.overlay },
      _react2.default.createElement(
        'div',
        { style: styles.content },
        _react2.default.cloneElement(this.props.children)
      )
    );
  }

});