'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isFunction2 = require('lodash/isFunction');

var _isFunction3 = _interopRequireDefault(_isFunction2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _loreUtils = require('lore-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _createReactClass2.default)({
  displayName: 'Request',

  propTypes: {
    request: _propTypes2.default.object,
    reducer: _propTypes2.default.string.isRequired,
    singleton: _propTypes2.default.bool.isRequired,
    onSuccess: _propTypes2.default.func.isRequired,
    onError: _propTypes2.default.func.isRequired,
    children: _propTypes2.default.node
  },

  getDefaultProps: function getDefaultProps() {
    return {
      singleton: false
    };
  },

  getInitialState: function getInitialState() {
    return {
      request: this.props.request
    };
  },

  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    var storeState = lore.store.getState();
    var request = this.props.singleton ? storeState[this.props.reducer] : storeState[this.props.reducer].byCid[nextProps.request.cid];

    // if the resource was deleted, it typically won't be the in store
    if (this.state.request && this.state.request.state === _loreUtils.PayloadStates.DELETING && !request) {
      this.props.onSuccess();
      this.setState({
        request: request
      });
    }

    if (!request) {
      return;
    }

    if (request.state === _loreUtils.PayloadStates.RESOLVED || request.state === _loreUtils.PayloadStates.MANAGED || request.state === _loreUtils.PayloadStates.DELETED) {
      this.props.onSuccess(request);
    }

    if (request.state === _loreUtils.PayloadStates.ERROR_CREATING || request.state === _loreUtils.PayloadStates.ERROR_UPDATING || request.state === _loreUtils.PayloadStates.ERROR_FETCHING || request.state === _loreUtils.PayloadStates.ERROR_DELETING || request.state === _loreUtils.PayloadStates.NOT_FOUND) {
      this.props.onError(request);
    }

    this.setState({
      request: request
    });
  },

  render: function render() {
    var children = this.props.children;


    if (children) {
      if ((0, _isFunction3.default)(children)) {
        return children();
      }
      return children;
    }

    return null;
  }
});