'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _createReactClass2.default)({
  displayName: 'SuccessMessage',

  propTypes: {
    title: _propTypes2.default.string.isRequired,
    message: _propTypes2.default.string.isRequired
  },

  getInitialState: function getInitialState() {
    return {
      isVisible: true
    };
  },

  componentDidMount: function componentDidMount() {
    var _this = this;

    this.isMounted = true;

    setTimeout(function () {
      if (_this.isMounted) {
        _this.setState({
          isVisible: false
        });
      }
    }, 3000);
  },

  componentWillUnmount: function componentWillUnmount() {
    this.isMounted = false;
  },

  getDefaultProps: function getDefaultProps() {
    return {
      title: 'Well done!',
      message: 'You successfully read this important alert message.'
    };
  },

  render: function render() {
    var isVisible = this.state.isVisible;


    return _react2.default.createElement(
      'div',
      { className: 'alert alert-success', style: { display: isVisible ? 'block' : 'none' } },
      _react2.default.createElement(
        'strong',
        null,
        this.props.title
      ),
      ' ',
      this.props.message
    );
  }

});