'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isFunction2 = require('lodash/isFunction');

var _isFunction3 = _interopRequireDefault(_isFunction2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = function (form, props, name) {
  var options = props.options,
      label = props.label,
      optionLabel = props.optionLabel,
      other = _objectWithoutProperties(props, ['options', 'label', 'optionLabel']);

  return _react2.default.createElement(
    _loreReactForms.Field,
    { name: name },
    function (field) {
      var errorText = field.touched && field.error;

      return _react2.default.createElement(
        'div',
        { className: 'form-group ' + (errorText ? 'has-error' : '') },
        _react2.default.createElement(
          'label',
          null,
          label
        ),
        _react2.default.createElement(
          _loreHookConnect.Connect,
          { callback: function callback(getState, props) {
              return {
                options: (0, _isFunction3.default)(options) ? options(getState, props) : options
              };
            } },
          function (connect) {
            return _react2.default.createElement(
              'select',
              _extends({
                className: 'form-control',
                value: field.value || '',
                onChange: function onChange(event) {
                  var value = event.target.value;
                  field.onBlur();
                  field.onChange(field.name, value ? Number(value) : value);
                },
                style: { width: '100%' }
              }, other),
              [_react2.default.createElement('option', { key: '', value: '' })].concat(connect.options.data.map(function (datum) {
                return _react2.default.createElement(
                  'option',
                  { key: datum.id, value: datum.id },
                  (0, _isFunction3.default)(optionLabel) ? optionLabel(datum) : datum.data[optionLabel]
                );
              }))
            );
          }
        ),
        errorText ? _react2.default.createElement(
          'span',
          { className: 'help-block' },
          errorText
        ) : null
      );
    }
  );
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _loreReactForms = require('lore-react-forms');

var _loreHookConnect = require('lore-hook-connect');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }