'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ErrorMessage = require('./ErrorMessage');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _loreUtils = require('lore-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _createReactClass2.default)({
  displayName: 'RequestError',

  propTypes: {
    request: _propTypes2.default.object,
    error: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array, _propTypes2.default.object]),
    children: _propTypes2.default.func
  },

  render: function render() {
    var _props = this.props,
        request = _props.request,
        error = _props.error,
        children = _props.children;


    if (error) {
      return _react2.default.createElement(_ErrorMessage2.default, { error: error });
    }

    if (request) {
      if (children) {
        var _error = children(request);
        if (_error) {
          return _react2.default.createElement(_ErrorMessage2.default, { error: _error });
        }
      }

      if (request.state === _loreUtils.PayloadStates.ERROR_CREATING || request.state === _loreUtils.PayloadStates.ERROR_UPDATING || request.state === _loreUtils.PayloadStates.ERROR_FETCHING || request.state === _loreUtils.PayloadStates.ERROR_DELETING) {
        return _react2.default.createElement(_ErrorMessage2.default, { error: request.error });
      }
    }

    return null;
  }

});
module.exports = exports['default'];