'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (form, props, name) {
  var checked = props.checked,
      label = props.label,
      description = props.description;


  return _react2.default.createElement(
    _loreReactForms.Field,
    { name: name },
    function (field) {
      var errorText = field.touched && field.error;

      return _react2.default.createElement(
        'div',
        { className: 'checkbox' },
        _react2.default.createElement(
          'label',
          null,
          _react2.default.createElement('input', {
            type: 'checkbox',
            checked: checked,
            onChange: function onChange(event) {
              field.onBlur();
              field.onChange(field.name, event.target.checked);
            }
          }),
          label
        ),
        errorText ? _react2.default.createElement(
          'span',
          { className: 'help-block' },
          errorText
        ) : null,
        _react2.default.createElement(
          'small',
          { className: 'form-text text-muted' },
          description
        )
      );
    }
  );
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _loreReactForms = require('lore-react-forms');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default'];