'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (form, props, name) {
  var label = props.label,
      placeholder = props.placeholder,
      description = props.description,
      rows = props.rows;


  return _react2.default.createElement(
    _loreReactForms.Field,
    { name: name },
    function (field) {
      var errorText = field.touched && field.error;

      return _react2.default.createElement(
        'div',
        { className: 'form-group ' + (errorText ? 'has-error' : '') },
        _react2.default.createElement(
          'label',
          null,
          label
        ),
        _react2.default.createElement('textarea', {
          className: 'form-control',
          rows: rows || 3,
          style: { maxWidth: '100%', minWidth: '100%' },
          name: field.name,
          value: field.value,
          onFocus: field.onFocus,
          onBlur: field.onBlur,
          placeholder: placeholder,
          onChange: function onChange(event) {
            field.onChange(field.name, event.target.value);
          }
        }),
        errorText ? _react2.default.createElement(
          'span',
          { className: 'help-block' },
          errorText
        ) : null,
        _react2.default.createElement(
          'small',
          { className: 'form-text text-muted' },
          description
        )
      );
    }
  );
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _loreReactForms = require('lore-react-forms');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default'];